sr   = 44100
kr   = 44100;use sr=kr please
ksmps= 1
zakinit 80,80; locations 0,1,2 & 3
gaout init 0

instr 1; instr 1 acts like "the player" and instr 2 like "the instrument"
;instr 2 must be active troughout the entire piece
;instr 1 is activated at each note event

kcounter instimes
;SCO SETUP
ifrequency = p4
;print ifrequency; displays current note being played
ifreq = p4/3;cpspch(p4);delay line length = 1/4 of period
print ifreq; displays current note being played
kfreq init ifreq

iamp = 5000;2150

ittime = 6/ifreq
irel = 4/ifreq

kamp7 = 1
;xtratim irel
p3 = p3+irel
icontrol zir 0; = 0 at compilation start time
icontrol = (icontrol == 0 ? 1:0);this swaps bores at each new event
ziw icontrol,0
ziw ifreq, icontrol+1;writes frq. at zk location 1 or 2. First is 2 <-- !

kdepth linseg 5,.5,100,100,20;FIX THIS
kspeed linseg 0,.3,0,.5,4.5,100,6;FIX THIS
kvibr oscil kdepth,kspeed,1
;vibrato most noticeable at small amplitudes
kp0 linseg 0,ittime,iamp,p3-ittime-irel,iamp,irel,0

knoize gauss .0015*kp0;add some pressure-dependent breath noise

kp0 = kp0+knoize+kvibr

zkwm kp0,3;mixes flows at zk location 3 

;weighting factor for bore swap
;activated at each new event

istart = icontrol
iend = 1-istart
transition:
kweight line istart,ittime,iend
kweight tablei kweight,4,1;a smooth sigmoidal transition

zkw kweight,4

;;;;;;;
;pitch tracker

;wait before starting to track the pitch
timout	0, .05, skip; skip transient or 0 initial (optional)

;autotune: ;gradually approximate the right pitch

;once the pitch is reached skip autotune to allow some vibrato
;if kcounter > .3 goto skip

kpitch, krms  pitchamdf  gaout, ifreq/1.5, ifreq*1.5 ,ifreq  ; extract pitch and envelope
kpitch0 init kpitch

kdf init 1.00002;1.0002;frequency multiplier
;kdf big -> corrects the pitch faster
;kdf small -> works smoothly and is more reliable

if ((kpitch < ifreq && kpitch0 < ifreq) || (kpitch > ifreq && kpitch0 > ifreq)) goto nochange
kdf = sqrt(kdf);reduce the step when approaching the right pitch

nochange:

if kpitch<ifreq goto higher
lower:
    kfreq  = kfreq/kdf;higher pitch -> lower the freq.
goto next
higher:
    kfreq  = kfreq*kdf;lower pitch -> raise the freq.
goto next

next:
kpitch0 = kpitch
zkw kfreq, icontrol+1;
;printk .1,kpitch

skip:
output:
endin


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
instr 2
;MIDIfied GRALLOT model based on a tenora model
;tenora:double-reed conical woodwind, a catalan tenor shawn
;embochure model from Ana Barjau
;integration scheme by Maarten van Walstijm
;loosely based on an Acustica article (Vol.89 pp.204-210)
;written by Ana Barjau & J. Agull with some modifications
;coded to Csound by Josep M Comajuncosas / mar99-aug99
;thanks to Ana Barjau for his friendly collaboration
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

ipi =  3.14159265359
inumb_iter = 3; number of iterations, suggested 1 to 3
; used in the Newton-Rhapson method.

;default tenora values
ih2 = .0016;entrance section height of the reed in equilibrium
im2 = .016; entrance section width of the reed in equilibrium
ifr = 900; reed resonance frequency
iwr = 2*ipi*ifr; normalized in radians/cycle
ier = .01776; = (B*(.4e-6)^(-2/3))^(-3/2) where B = airflow constant ~ 0.08
ihr = 0.0004;aperture of the reed in equilibrium; DONT CHANGE
iq  = 1.5
ist = .000013;bore input section area
isr = .00002;effective reed area
is0 = .00001;blowing pressure effective reed area
is  = .00002;internal effective reed area
ic0 = is0/is
idamp = .2;.15<idamp<.4;reed damping coefficient
iur = .25;for an effective lip&reed mass of about 3-10mg set .15<iur<.4
;iur variable -> stiffness variable
igamma = .004;weighting parameter for Bernoully pressure .001-.008

ic  = 343;sound velocity
irho = 1.21;air density
iz0 = (irho*ic)/ist

;initialise variables
kuf1 init 0;normal volume flow
apm1 init 0;mouthpiece pressure at t=0 is 0
apr2 init 0;reflected pressure wave from the tube
kx1 init ihr;previous reed aperture (at t=-1)
kx2 init ihr;initial reed aperture (at t=0)


;reed entrance section area
ka = (8*im2/(ipi*ih2))*(kx2)^2

;Bernoully pressure
kpb = igamma*.5*irho*(kuf1/ka)^2

it=1/sr;sampling period

ic1 = idamp*2*iwr*it
ic2 = it*it*iwr*iwr
ic3 = -it*it/iur

ic6 = isr/it

kfc init 1
kfk = ihr-kx2

k1 = ic1 * kfc
k2 = ic2 * kfk
k3 = 2 - k1
k4 = k1 - 1


kp0 zkr 3;get flow value from zk location 3

adp1 = ic0*kp0 - (apm1-kpb)

kdp1 downsamp adp1;necessary to compute a k-rate variable
kpr2 downsamp apr2;idem

kx0 = kx1	
kx1 = kx2		
kx2 = k3*kx1 + k4*kx0 + ic3*kdp1 + k2


;Clipping Routine for clarinet beating

;the routine uses a value kclipd that sets the distance bewteen
;kclipg and kclipx1. So for high values of kclipd, the clipping is
;very 'soft'. and for kclipd=0 there is no softening at all,
;and the clipping is equivalent to the way we have it now.

;Clipping Routine for clarinet beating
;the clipping routine has two control parameters:
;kclipg = minimum value for x to clip at
;kclipm = 'softness' of clipping: m corresponds to
;the half-width (kclipd) of the range in which the clipping
;does 'circular' waveshaping
;kclipm is experessed in fraction(0 to 1) of the equilibrium opening ihr
;0 means no softening at all
;1 means very much softening

;example values

kcliph = ihr
kclipg = ihr/5
kclipm = 0.2;

;initialisation part of the clipping routine

kclipd = kclipm*kcliph;
kclipk = 1 - sqrt(2);
kclipx1 = kclipg - kclipd;
kclipa = kclipx1;
kclipr = (kclipa-kclipg)/kclipk;
kclipb = kclipr + kclipg;
kclipx2 = (kclipx1 + kclipb)/2;

;the routine itself

if kx2 < kclipx1 goto full
goto nofull
full:
kx2 = kclipg;full clipping
goto clipped

nofull:
if kx2 > kclipx2 goto noclip
goto nonoclip
noclip:
kx2 = kx2;no clipping
goto clipped

nonoclip:
kx2 = kclipb - sqrt(kclipr*kclipr - (kx2-kclipx1)*(kx2-kclipx1));circular (soft) clipping
clipped:

kur2 = ic6*(kx2 - kx1);extra flow caused by the reed motion


;effective air mass through the entrance section
;inertance of the air through the reed
ih2m2 = sqrt (ih2/im2)
kir = (irho/(2*ipi*(ihr)))*ih2m2*(1+2*log(2*ih2m2));constant = at ihr


kc7 = -(iz0*it/kir + 1)
kc8 = -it*ier/kir
kc9 = it/kir

kd1 = kc7	
kd2 = kc8/(kx2^3);FOR DOUBLE REEDS	
kd3 = kc9*(kp0 - 2*kpr2 + iz0*kur2) + kuf1	
	
;NEWTON-RHAPSON iteration.

;kuf1 is used as initial value.

 kd4=kd2*iq;
 kd5=kd4-kd2;
 kxo=kuf1;

kcounter = inumb_iter;reinitialise counter
iter:

kbsaxo = abs(kxo)
ksign = kbsaxo;temp. variable
ksign_axo = (ksign<0?-1:1)
kbsaxoq1 = kbsaxo^(iq-1)
kbsaxoq  = kbsaxo*kbsaxoq1

   kxo=(kd5*ksign_axo*kbsaxoq-kd3)/(kd1+kd4*kbsaxoq1)

kcounter = kcounter - 1
if kcounter > 0 goto iter; iterate inumb_iter times
kuf2 = kxo;get value
	
kub2 = kuf2 - kur2;total volume flow for next pass	
api2 = iz0*kub2 + apr2;ingoing pressure wave into the tube
apm2 = api2 + apr2;mouthpiece pressure		

;CILYNDRICAL WAVEGUIDE (lowpass inverting)
;bore logic : swap if a new note has started
;this feature allows playing legato notes

kbore1 zkr 1
kbore2 zkr 2
;this conditional is normally skipped except at init time
;when bore1 can have its lenght undefined
kbore1 = (kbore1==0?kbore2:kbore1)
kweight zkr 4

kdlt1 = 1/kbore1
kdlt2 = 1/kbore2

;overall bore correction due to the reed system (in samples)
;its rather complicated to compute (see Nederveens PhD Thesis)
;there is some freq. dependent delay also :-(
;and the phase delay caused by the tonehole (7 to 4 samples)
;so I computed it empirically
;and further corrected the estimated value by the pitch tracker

ktune1 tablei 100*octcps(kbore1),7
ktune2 tablei 100*octcps(kbore2),7
kdlt1 = kdlt1+ktune1/sr
kdlt2 = kdlt2+ktune2/sr

;@P=5000 6.00/-370 6.06/-270 7.00/-200 7.06/-150 8.00/-112 8.06/-87 9.00/-58 9.06/-53


;calculations for fractional delay interpolation filter
;(by now a simple linear interpolator)
kdltn1 = int((sr*kdlt1)/2)
kdltn2 = int((sr*kdlt2)/2)
kdltf1 = frac((sr*kdlt1)/2);note than time=int(time)+frac(time) ;-)
kdltf2 = frac((sr*kdlt2)/2)

;pressure sent to two bores in parallel
bore1:
atemp11 delayr 1/20
api31 deltapn kdltn1
;open hole reflectance filter designed by Maarten
aprf1 biquad api31,1,1.60866845795955,0.79033697044981,1,-0.00843592161383,-0.75860644369670
aprf1 = aprf1*-0.06734822596636

afdf12 biquad aprf1, 1-kdltf1, kdltf1,0,1,0,0
delayw api2

bore2:
atemp21 delayr 1/20
api32 deltapn kdltn2
;open hole reflectance filter designed by Maarten
aprf2 biquad api32,1,1.60866845795955,0.79033697044981,1,-0.00843592161383,-0.75860644369670
aprf2 = aprf2*-0.06734822596636

afdf22 biquad aprf2, 1-kdltf2, kdltf2,0,1,0,0
delayw api2

;signal reaching the bore closed end
apr3 = kweight*afdf12 + (1-kweight)*afdf22

;output signal
api3 = kweight*api31 + (1-kweight)*api32

;SOUND OUTPUT

;aout butterhp api3,p4*1.1

;High-Pass Filter: 
aout biquad api3,1,-1.996950273367395,0.996978312332094,1,-1.706660482696107,0.707131817477271
gaout = aout* -0.834797947580800
out gaout

;update variables for next pass
kuf1 = kuf2
apm1 = apm2
apr2 = apr3


zkcl 3,3;clean mixer
; (flow pressure contributed by the 2 overlapping notes)
endin

